
rm(list=ls())
################Setting work directory#################

library(grid)
library(msm)
setwd("/Users/lyonszhang/Google Drive/revision of MM ANDI smmr/R coding")


###############Read data from files###################
mydata<-read.csv("final cleaned data 0 ultimate vols.csv")
traindata<-read.csv("all data before AD.csv")
###############retrieve ID for each group##############

select12<-unique(mydata$RID[(mydata$DXreal==12)])
select21<-unique(mydata$RID[(mydata$DXreal==21)])
select23<-unique(mydata$RID[(mydata$DXreal==23)])
select32<-unique(mydata$RID[(mydata$DXreal==32)])

select11<-unique(mydata$RID[(mydata$DXreal==11)])
select22<-unique(mydata$RID[(mydata$DXreal==22)])
select33<-unique(mydata$RID[(mydata$DXreal==33)])

select11<-select11[!((select11 %in% select12) | (select11 %in% select22)| (select11 %in% select21))]
select22<-select22[!((select22 %in% select23) | (select22 %in% select21)| (select22 %in% select11) |(select22 %in% select12)|(select22 %in% select33)|(select22 %in% select32))]
select33<-select33[!((select33 %in% select32)|(select33 %in% select11)|(select33 %in% select23)|(select33 %in% select11))]

length(select11)
length(select22)
length(select33)

select1<-unique(mydata$RID[(mydata$DXreal==11)])
select2<-unique(mydata$RID[(mydata$DXreal==22)])
select3<-unique(mydata$RID[(mydata$DXreal==33)])

t<-select2[select2 %in% select1]
# for(i in 1:length(t))
# {
#   print(c(t[i],subset(mydata,RID==t[i])$DX))
# }

s123<-select23[select23 %in% select12]
#[1] 223 548 778
#move across 3 states

s121<-select12[select12 %in% select21]
#[1] 112 669
#oscillate between 1 and 2

s232<-select23[select23 %in% select32]
#[1] 162 429
##oscillate between 2 and 3

s12<-c(106,127,210,232,454,779,843,972,1063,1169)
s21<-c(291,384,422,443,551,668,722,1092)

select12<-sort(unique(c(select12,s12[! s12 %in% select12])))
select12<-select12[!select12 %in% c(s123,s121)]
select21<-sort(unique(c(select21,s21[! s21 %in% select21])))
select21<-select21[!select21 %in% c(s123,s121)]
select22<-select22[! select22 %in% c(select12,select21)]



t<-select2[select2 %in% select3]
t<-t[!t %in% c(s123,s232)]
# for(i in 1:length(t))
# {
#   print(c(t[i],subset(mydata,RID==t[i])$DX))
# }

select23<-sort(unique(c(select23,select23[!select23 %in% t])))
select23<-select23[!select23 %in% c(s123,s232)]
select32<-select32[!select32 %in% c(s123,s232)]

length(select11)
length(select22)
length(select33)
length(select32)
length(select23)
length(select12)
length(select21)
s123
s121
s232

###############genertate a variable to indicate the groups#################

DXsub<-rep(0,length(mydata$RID))
DXsub[mydata$RID %in% select11]<-11
DXsub[mydata$RID %in% select12]<-12
DXsub[mydata$RID %in% select21]<-21
DXsub[mydata$RID %in% select22]<-22
DXsub[mydata$RID %in% select23]<-23
DXsub[mydata$RID %in% select33]<-33
DXsub[mydata$RID %in% select32]<-32
DXsub[mydata$RID %in% s123]<-123
DXsub[mydata$RID %in% s121]<-121
DXsub[mydata$RID %in% s232]<-232
mydata$DXsub<-DXsub

mydata$DXsub<-factor(mydata$DXsub,labels=c("D11","D12","D21","D22","D23","D32","D33","D121","D123","D232"))
# mydata[,"Ven_scale"]<-100*mydata[,"Ven_scale"]
# mydata[,c("Hip_scale","Ent_scale","Fus_scale","Mid_scale")]<-1000*mydata[,c("Hip_scale","Ent_scale","Fus_scale","Mid_scale")]
# mydata[,"Who_scale"]<-10*mydata[,"Who_scale"]

######################Model fitting####################

q3<-rbind(c(0,0.2,0),c(0.2,0,.1),c(0,0,0))
rownames(q3)<-colnames(q3)<-c("NC","MCI","AD")

ADNI.msm<-msm(DX~Years_bl,subject=RID,data=traindata,gen.inits=TRUE,covariates=~AGEreal+CDRSB+MMSE+APOE4+Ven_scale+Hip_scale+Who_scale+Ent_scale+Fus_scale+Mid_scale,qmatrix=q3,method="Nelder-Mead",control=list(maxit=30000))

#####################prediction#####################

f<-function(model,test)
{
#	ncovar<-length(splitFormula(stan.mix1.msm$covariates,sep="+"))
#    test<-na.omit(test)
	varname<-unlist(strsplit(gsub("[[:blank:]]", "", deparse(model$covariates[[2]])),split="[+]"))
	varlist<-subset(test,select=varname)
	choose<-unique(test$RID)
    P<-rep(NA,dim(test)[1])
    Q<-rep(NA,dim(test)[1])
    k<-1
    n<-0
    for(i in 1:length(choose))
    {
    
            temp<-as.list(varlist[k,])
            sub<-subset(test,RID==choose[i])
            pm<-pmatrix.msm(model,t=0,t1=test[k,"Years_bl"],covariates=temp,ci="none")
            qm<-qmatrix.msm(model, covariates=temp, sojourn=FALSE, ci="none")
		    P[k]<-pm[1,2]
		    Q[k]<-qm[1,2] 
		    k<-k+1
    		for(j in 2:nrow(sub))
    		{
    			temp<-as.list(varlist[k,]) #need to change accordingly  			
                pm<-pmatrix.msm(model,t=test[k,"Years_bl"]-test[k-1,"Years_bl"],t1=test[k-1,"Years_bl"],covariates=temp,ci="none")
                qm<-qmatrix.msm(model, covariates=temp, sojourn=FALSE, ci="none")
		        P[k]<-pm[1,2]
		        Q[k]<-qm[1,2] 
		        if(k==dim(test)[1])
		        {
		        	break
		        }
		        k<-k+1
		    }

	}
    test$P<-P
    test$Q<-Q
    return(test)
}

subdata<-mydata[,c("RID","Years_bl","DX","DXsub","M","AGEreal","CDRSB","MMSE","APOE4","Ven_scale","Hip_scale","Who_scale","Ent_scale","Fus_scale","Mid_scale")]
subdata<-na.exclude(subdata)
updata<-f(ADNI.msm,subdata)

##########################plots########################

#tem<-na.exclude(updata[updata$DXsub=='D11'|updata$DXsub=='D22'|updata$DXsub=='D23'|updata$DXsub=='D33',c("P","DXsub","M")])
tem<-na.exclude(updata[updata$DXsub=='D12'|updata$DXsub=='D21'|updata$DXsub=='D23',c("P","DXsub","M")])
tem<-subset(tem,M<50)
tempt<-doBy::summaryBy(form = P ~ DXsub:M, data = tem, FUN = length)


df <- with(tem, aggregate(P, list(M=M, Group=DXsub), mean))
df$se <- with(tem , aggregate(P, list(M=M, Group=DXsub), 
              function(x) sd(x))[,3])/sqrt(tempt$P.length)


setEPS()
postscript("TPprediction12byvisit.eps")

gp <- ggplot(df, aes(x=M, y=x, colour=Group, group=Group))
gp + geom_line(aes(linetype=Group), size=1.2) + 
     geom_point(aes(shape=Group), size=3) + 
     geom_errorbar(aes(ymax=x+se, ymin=x-se), width=.2)+theme_bw()+

scale_y_continuous('Transition probability',expand=c(0,0))+

scale_x_continuous('Time on study (months)',limits=c(0,50))+

#theme(legend.position=c(0.75,0.75))+

theme(axis.line = element_line(colour = "black",size=1.5))+

theme(panel.grid.major = element_blank())+

theme(panel.grid.minor = element_blank())+

theme(panel.border = element_blank())+

theme(panel.background = element_blank())+

theme(text = element_text(size=24,colour = "black",face='bold'))+

theme(legend.key.size = unit(2, "cm"))

dev.off()

##################################

tem<-na.exclude(updata[updata$DXsub=='D12'|updata$DXsub=='D21'|updata$DXsub=='D23',c("Q","DXsub","M")])
tem<-subset(tem,M<50)
tem$Q<-log(tem$Q)
tempt<-doBy::summaryBy(form = Q ~ DXsub:M, data = tem, FUN = length)


df <- with(tem, aggregate(Q, list(M=M, Group=DXsub), mean))
df$se <- with(tem , aggregate(Q, list(M=M, Group=DXsub), 
              function(x) sd(x))[,3])/sqrt(tempt$Q.length)


setEPS()
postscript("TQprediction12byvisit.eps")

gp <- ggplot(df, aes(x=M, y=x, colour=Group, group=Group))
gp + geom_line(aes(linetype=Group), size=1.2) + 
     geom_point(aes(shape=Group), size=3) + 
     geom_errorbar(aes(ymax=x+se, ymin=x-se), width=.2)+theme_bw()+

scale_y_continuous('Transition rate',expand=c(0,0))+

scale_x_continuous('Time on study (months)',limits=c(0,50))+

#theme(legend.position=c(0.75,0.75))+

theme(axis.line = element_line(colour = "black",size=1.5))+

theme(panel.grid.major = element_blank())+

theme(panel.grid.minor = element_blank())+

theme(panel.border = element_blank())+

theme(panel.background = element_blank())+

theme(text = element_text(size=24,colour = "black",face='bold'))+

theme(legend.key.size = unit(2, "cm"))

dev.off()

f<-function(model,test)
{
# ncovar<-length(splitFormula(stan.mix1.msm$covariates,sep="+"))
#    test<-na.omit(test)
  varname<-unlist(strsplit(gsub("[[:blank:]]", "", deparse(model$covariates[[2]])),split="[+]"))
  varlist<-subset(test,select=varname)
  choose<-unique(test$RID)
    P<-rep(NA,dim(test)[1])
    Q<-rep(NA,dim(test)[1])
    k<-1
    n<-0
    for(i in 1:length(choose))
    {
    
            temp<-as.list(varlist[k,])
            sub<-subset(test,RID==choose[i])
            pm<-pmatrix.msm(model,t=0,t1=test[k,"Years_bl"],covariates=temp,ci="none")
            qm<-qmatrix.msm(model, covariates=temp, sojourn=FALSE, ci="none")
        P[k]<-pm[2,3]
        Q[k]<-qm[2,3] 
        k<-k+1
        for(j in 2:nrow(sub))
        {
          temp<-as.list(varlist[k,]) #need to change accordingly        
                pm<-pmatrix.msm(model,t=test[k,"Years_bl"]-test[k-1,"Years_bl"],t1=test[k-1,"Years_bl"],covariates=temp,ci="none")
                qm<-qmatrix.msm(model, covariates=temp, sojourn=FALSE, ci="none")
            P[k]<-pm[2,3]
            Q[k]<-qm[2,3] 
            if(k==dim(test)[1])
            {
              break
            }
            k<-k+1
        }

  }
    test$P<-P
    test$Q<-Q
    return(test)
}

subdata<-mydata[,c("RID","Years_bl","DX","DXsub","M","AGEreal","CDRSB","MMSE","APOE4","Ven_scale","Hip_scale","Who_scale","Ent_scale","Fus_scale","Mid_scale")]
subdata<-na.exclude(subdata)
updata<-f(ADNI.msm,subdata)
#tem<-na.exclude(updata[updata$DXsub=='D11'|updata$DXsub=='D22'|updata$DXsub=='D23'|updata$DXsub=='D33',c("P","DXsub","M")])
tem<-na.exclude(updata[updata$DXsub=='D12'|updata$DXsub=='D21'|updata$DXsub=='D23',c("P","DXsub","M")])
tem<-subset(tem,M<50)
tempt<-doBy::summaryBy(form = P ~ DXsub:M, data = tem, FUN = length)


df <- with(tem, aggregate(P, list(M=M, Group=DXsub), mean))
df$se <- with(tem , aggregate(P, list(M=M, Group=DXsub), 
              function(x) sd(x))[,3])/sqrt(tempt$P.length)


setEPS()
postscript("TPprediction23byvisit.eps")

gp <- ggplot(df, aes(x=M, y=x, colour=Group, group=Group))
gp + geom_line(aes(linetype=Group), size=1.2) + 
     geom_point(aes(shape=Group), size=3) + 
     geom_errorbar(aes(ymax=x+se, ymin=x-se), width=.2)+theme_bw()+

scale_y_continuous('Transition probability',expand=c(0,0))+

scale_x_continuous('Time on study (months)',limits=c(0,50))+

#theme(legend.position=c(0.75,0.75))+

theme(axis.line = element_line(colour = "black",size=1.5))+

theme(panel.grid.major = element_blank())+

theme(panel.grid.minor = element_blank())+

theme(panel.border = element_blank())+

theme(panel.background = element_blank())+

theme(text = element_text(size=24,colour = "black",face='bold'))+

theme(legend.key.size = unit(2, "cm"))

dev.off()

##################################

tem<-na.exclude(updata[updata$DXsub=='D12'|updata$DXsub=='D21'|updata$DXsub=='D23',c("Q","DXsub","M")])
tem<-subset(tem,M<50)
tem$Q<-log(tem$Q)
tempt<-doBy::summaryBy(form = Q ~ DXsub:M, data = tem, FUN = length)


df <- with(tem, aggregate(Q, list(M=M, Group=DXsub), mean))
df$se <- with(tem , aggregate(Q, list(M=M, Group=DXsub), 
              function(x) sd(x))[,3])/sqrt(tempt$Q.length)


setEPS()
postscript("TQprediction23byvisit.eps")

gp <- ggplot(df, aes(x=M, y=x, colour=Group, group=Group))
gp + geom_line(aes(linetype=Group), size=1.2) + 
     geom_point(aes(shape=Group), size=3) + 
     geom_errorbar(aes(ymax=x+se, ymin=x-se), width=.2)+theme_bw()+

scale_y_continuous('Transition rate',expand=c(0,0))+

scale_x_continuous('Time on study (months)',limits=c(0,50))+

#theme(legend.position=c(0.75,0.75))+

theme(axis.line = element_line(colour = "black",size=1.5))+

theme(panel.grid.major = element_blank())+

theme(panel.grid.minor = element_blank())+

theme(panel.border = element_blank())+

theme(panel.background = element_blank())+

theme(text = element_text(size=24,colour = "black",face='bold'))+

theme(legend.key.size = unit(2, "cm"))

dev.off()





